defstar {
	name { DownCounter }
	domain { CGC }
	desc { 
A down counter from the input value to zero. 
Code is generated for each step operation instead of generating all outputs
at once.
	}
	version { @(#)CGCDownCounter.pl	1.5	1/1/96 }
	author { Soonhoi Ha }
	copyright {
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
	}
	location { CGC main library }
	explanation {
This star generates (int-1), (int-2), ... 1,0 samples for (int) input.
Input should be a positive integer (can not be zero).
	}
	input {
		name { input }
		type { int }
	}
	input {
		name { control }
		type { int }
	}
	output {
		name { output }
		type { int }
		num { 0 }
	}
	state {
		name { status }
		type { int }
		default { "0" }
		desc { monitoring the control value }
		attributes { A_NONCONSTANT|A_NONSETTABLE }
	}
	method {
		name { readTypeName }
		access { public }
		type { "const char *" }
		code { return "UpSample"; }
	}

	codeblock (block) {
	if ($ref(status) == 0) {
		if ($ref(input) > 0) {
			$ref(output) = $ref(input) - 1;
		} 
	} else {
		$ref(output) = $ref(output) - 1;
	}
	$ref(status) = $ref(output);
	}
	go {
		addCode(block);
	}
}

