static const char file_id[] = "CGCSDFReceive.pl";
// .cc file generated from CGCSDFReceive.pl by ptlang
/*
Copyright (c) 1995-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "CGCSDFReceive.h"

const char *star_nm_CGCSDFReceive = "CGCSDFReceive";

const char* CGCSDFReceive :: className() const {return star_nm_CGCSDFReceive;}

ISA_FUNC(CGCSDFReceive,CGCSDFBase);

Block* CGCSDFReceive :: makeNew() const { LOG_NEW; return new CGCSDFReceive;}

const char* CGCSDFReceive :: portInit() {
# line 25 "CGCSDFReceive.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"	input {\n"
"	    name{" << (sdfPortName) << "}\n"
"	    type{" << (sdfPortType) << "}\n"
"	}\n";
	return (const char*)_str_;
}

const char* CGCSDFReceive :: blockXfr() {
# line 36 "CGCSDFReceive.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"	for (int $label(i) = 0; $label(i) < " << (numXfer) << " ; $label(i)++)\n"
"	    $ref(output,$label(i)) = " << (sdfPortName) << "%$label(i);\n";
	return (const char*)_str_;
}

const char* CGCSDFReceive :: tokenXfr() {
# line 40 "CGCSDFReceive.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"	$ref(output) = " << (sdfPortName) << "%0;\n";
	return (const char*)_str_;
}

const char* CGCSDFReceive :: complexBlockXfr() {
# line 43 "CGCSDFReceive.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"	for (int $label(i) = 0; $label(i) < " << (numXfer) << " ; $label(i)++) {\n"
"	    " << (cgcToPtolemyTempVariable) << " = " << (sdfPortName) << "%$label(i);\n"
"	    $ref(output,$label(i)).real = " << (cgcToPtolemyTempVariable) << ".real();\n"
"	    $ref(output,$label(i)).imag = " << (cgcToPtolemyTempVariable) << ".imag();\n"
"	}\n";
	return (const char*)_str_;
}

const char* CGCSDFReceive :: complexTokenXfr() {
# line 50 "CGCSDFReceive.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"	" << (cgcToPtolemyTempVariable) << " = " << (sdfPortName) << "%0;\n"
"	$ref(output).real = " << (cgcToPtolemyTempVariable) << ".real();\n"
"	$ref(output).imag = " << (cgcToPtolemyTempVariable) << ".imag();\n";
	return (const char*)_str_;
}

const char* CGCSDFReceive :: fixBlockXfr() {
# line 55 "CGCSDFReceive.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"	for (int $label(i) = 0; $label(i) < " << (numXfer) << " ; $label(i)++) {\n"
"	    // It would be better here to get direct access to the\n"
"		// bits of the Fix class and copy them over.\n"
"		    // Unfortunately, there is no public method to do this\n"
"			// in Fix.h.  FIXME\n"
"			    double temp = " << (sdfPortName) << "%$label(i);\n"
"	    FIX_DoubleAssign($ref(output,$label(i)),temp);\n"
"	}\n";
	return (const char*)_str_;
}

const char* CGCSDFReceive :: fixTokenXfr() {
# line 65 "CGCSDFReceive.pl"
	static StringList _str_; _str_.initialize(); _str_ << 
"	// It would be better here to get direct access to the\n"
"	    // bits of the Fix class and copy them over.\n"
"		// Unfortunately, there is no public method to do this\n"
"		    // in Fix.h.  FIXME\n"
"			double temp = " << (sdfPortName) << "%0;\n"
"	FIX_DoubleAssign($ref(output),temp);\n";
	return (const char*)_str_;
}

CGCSDFReceive::CGCSDFReceive ()
{
	setDescriptor("CGC input from SDF communication");
	addPort(output.setPort("output",this,ANYTYPE));


}

void CGCSDFReceive::initCode() {
# line 32 "CGCSDFReceive.pl"
if (sdfPortType == FIX) portPrecision = output.precision();
	addCode(portInit(),"starPorts");
    CGCSDFBase::initCode();
}

void CGCSDFReceive::setup() {
# line 22 "CGCSDFReceive.pl"
output.setResolvedType(sdfPortType);
	output.setSDFParams(numXfer,maxDelay);
}

void CGCSDFReceive::go() {
# line 74 "CGCSDFReceive.pl"
if (sdfPortType == FIX) {
	    if (numXfer > 1) addCode(fixBlockXfr()); 
	    else addCode(fixTokenXfr());
	}
	else if (sdfPortType == COMPLEX) {
	    if (numXfer > 1) addCode(complexBlockXfr()); 
	    else addCode(complexTokenXfr());
	}
	else {
	    if (numXfer > 1) addCode(blockXfr()); 
	    else addCode(tokenXfr());
	}
}

// prototype instance for known block list
static CGCSDFReceive proto;
static RegisterBlock registerBlock(proto,"SDFReceive");
