/* 
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.

Permission is hereby granted, without written agreement and without
license or royalty fees, to use, copy, modify, and distribute this
software and its documentation for any purpose, provided that the
above copyright notice and the following two paragraphs appear in all
copies of this software.

IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY
FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS.

						PT_COPYRIGHT_VERSION_2
						COPYRIGHTENDKEY
*/
/*  Version @(#)PNForkNode.cc	2.4 1/1/96
    Author:	T.M. Parks
    Created:	28 August 1992

    Auto-forking version of PNGeodesic.
*/

static const char file_id[] = "PNForkNode.cc";

#ifdef __GNUG__
#pragma implementation
#endif

#include "PNForkNode.h"

// Class identification.
ISA_FUNC(PNForkNode, PNGeodesic);

// Identify node as persistent.
int PNForkNode::isItPersistent() const
{
    return TRUE;
}

// Make a new source connection.
PortHole* PNForkNode::setSourcePort(GenericPort &port,
				    int delay, const char* values)
{
    return autoFork.setSource(port, delay, values);
}

// Make a new destination connection.
PortHole* PNForkNode::setDestPort(GenericPort &port)
{
    // Make fork Star only after first connection.
    return autoFork.setDest(port);
}
