static const char file_id[] = "SDFFileEvalControl.pl";
// .cc file generated from SDFFileEvalControl.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFFileEvalControl.h"

const char *star_nm_SDFFileEvalControl = "SDFFileEvalControl";

const char* SDFFileEvalControl :: className() const {return star_nm_SDFFileEvalControl;}

ISA_FUNC(SDFFileEvalControl,SDFFileEval);

Block* SDFFileEvalControl :: makeNew() const { LOG_NEW; return new SDFFileEvalControl;}

# line 43 "SDFFileEvalControl.pl"
extern "C" {
	    #include "ptk.h"
	}

SDFFileEvalControl::SDFFileEvalControl ()
{
	setDescriptor("This is just like FileEval, except that it supports any number of\ninteger-valued inputs and outputs in addition to the anytype\ninputs and File outputs.  The integers can be referenced in\nthe \"command\" parameter using the syntax \"intin#1\", \"intin#2\", etc.,\nor \"intout#1\", \"intout#2\", etc.  If the command does not set\nthe integer output values (using the Tcl \"set\" command), then\nthe value of the outputs will be 0.");
	addPort(intin.setPort("intin",this,INT));
	addPort(intout.setPort("intout",this,INT));


}

void SDFFileEvalControl::begin() {
# line 34 "SDFFileEvalControl.pl"
if (sourceIfNeeded("fileevalcontrol_editcommand",
	    "$PTOLEMY/src/domains/sdf/dfm/stars/fileevalcontrolsupport.tcl")
	    == 0) {
	        return;
	}

        SDFFileEval::begin();
}

void SDFFileEvalControl::go() {
# line 85 "SDFFileEvalControl.pl"
SDFFileEval::go();

	// Produce integer outputs.
	MPHIter nexto(intout);
	PortHole *p;
	int num = 1;
	while ((p = nexto++) != 0) {
	    InfString cmd = "fileevalcontrol_getintout ";
	    cmd << tcl.id() << " " << num;
	    if (Tcl_GlobalEval(ptkInterp, cmd) != TCL_OK) {
		Error::abortRun(*this, ptkInterp->result);
		return;
	    }
	    int value;
	    if (Tcl_GetInt(ptkInterp, ptkInterp->result, &value) != TCL_OK) {
		cmd = "Integer output number ";
		cmd << num << " set to non-integer.\n" << ptkInterp->result;
		Error::abortRun(*this, (const char*) cmd);
		return;
	    }
	    (*p)%0 << value;
	    num++;
	}
}


int SDFFileEvalControl::evalneeded ()
{
# line 55 "SDFFileEvalControl.pl"
int result = SDFFileEval::evalneeded();

	    // Grab the control inputs.
	    MPHIter nexti(intin);
	    PortHole *p;
	    InfString controlin;
	    while ((p = nexti++) != 0) {
		// return a quoted string for Tcl consumption
		controlin += "{";
		controlin += ((*p)%0).print();
		controlin += "} ";
	    }

	    InfString cmd;
	    if (intin.numberPorts() > 0) {
		cmd << "set " << tcl.id() << "(intin) ";
		cmd << controlin << "\n";
	    }
	    cmd << "set " << tcl.id() << 
	    	"(numintout) " << intout.numberPorts() << "\n";
	    cmd << "fileevalcontrol_editcommand ";
	    cmd << tcl.id();
	    if (Tcl_GlobalEval(ptkInterp, (char*)cmd) != TCL_OK) {
		Error::abortRun(*this, ptkInterp->result);
		return 0;
	    }
	    return result;
}


// prototype instance for known block list
static SDFFileEvalControl proto;
static RegisterBlock registerBlock(proto,"FileEvalControl");
