static const char file_id[] = "SDFFileEvalString.pl";
// .cc file generated from SDFFileEvalString.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFFileEvalString.h"
#include "FileMessage.h"

const char *star_nm_SDFFileEvalString = "SDFFileEvalString";

const char* SDFFileEvalString :: className() const {return star_nm_SDFFileEvalString;}

ISA_FUNC(SDFFileEvalString,SDFFileEval);

Block* SDFFileEvalString :: makeNew() const { LOG_NEW; return new SDFFileEvalString;}

# line 43 "SDFFileEvalString.pl"
extern "C" {
	    #include "ptk.h"
	}

SDFFileEvalString::SDFFileEvalString ()
{
	setDescriptor("This command is just like the FileEval command, but with the addition\nof another set of outputs \"strout\".  This set of outputs is treated\na bit differently.  If the execution of the \"command\" parameter\nsets the variables \"strout#1\", \"strout#2\", etc., then the value\ngiven to those variables becomes the output filename.\nFor example, if \"command\" is \"set strout#1 foo\", then the output\nfilename is \"foo\".  If the \"command\" script does not set \"strout#i\"\nfor a connected output \"i\", then a temporary filename is generated.");
	addPort(strout.setPort("strout",this,FILEMSG));


}

void SDFFileEvalString::go() {
# line 48 "SDFFileEvalString.pl"
SDFFileEval::go();
	// Now step through the strout outputs and generate filenames.
	MPHIter nextp(strout);
	for (int i = 0; i < strout.numberPorts(); i++) {
	    FileMessage* fm;
	    // FIXME: The variables should not really be global.
	    // They should be in the the starID array.
	    InfString var = "strout#";
	    var << i;
	    if (Tcl_GetVar(ptkInterp,(char*)var,TCL_GLOBAL_ONLY) == TCL_OK) {
		fm = new FileMessage(ptkInterp->result);
	    } else {
		fm = new FileMessage();
	    }
	    Envelope pkt(*fm);
		
	    // Now send the filename to the output
	    PortHole* p = nextp++;
	    (*p)%0 << pkt;
	}
}

// prototype instance for known block list
static SDFFileEvalString proto;
static RegisterBlock registerBlock(proto,"FileEvalString");
