#ifndef _VHDLCompMap_h
#define _VHDLCompMap_h 1
/******************************************************************
Version identification:
@(#)VHDLCompMap.h	1.4 2/28/96

Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.

Permission is hereby granted, without written agreement and without
license or royalty fees, to use, copy, modify, and distribute this
software and its documentation for any purpose, provided that the
above copyright notice and the following two paragraphs appear in all
copies of this software.

IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY
FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS.

						PT_COPYRIGHT_VERSION_2
						COPYRIGHTENDKEY

 Programmer: Michael C. Williamson

 Methods defining VHDL CompMaps.

*******************************************************************/
#ifdef __GNUG__
#pragma interface
#endif

#include "VHDLObj.h"
#include "VHDLObjList.h"
#include "VHDLPortMap.h"
#include "VHDLGenericMap.h"

class VHDLCompMap : public VHDLObj
{
 public:
  // Constructors.
  VHDLCompMap();

  // Destructor.
  ~VHDLCompMap();

  // Type.
  StringList type;
  // Port map list.
  VHDLPortMapList* portMapList;
  // Generic map list.
  VHDLGenericMapList* genMapList;

  // Class Idenitification.
  /* virtual */ int isA(const char*) const;
  /* virtual */ const char* className() const;

  VHDLCompMap* newCopy();

 protected:
 private:
};

class VHDLCompMapList : public VHDLObjList
{
  friend class VHDLCompMapListIter;

 public:
  // Add VHDLCompMap to list.
  void put(VHDLCompMap& v) { VHDLObjList::put(v); }

  // Return first VHDLCompMap on list (const, non-const forms).
  VHDLCompMap* head() { return (VHDLCompMap*) VHDLObjList::head(); }
  const VHDLCompMap* head() const {
    return (const VHDLCompMap*) VHDLObjList::head();
  }

  // Remove a VHDLCompMap from the list.
  // Note:  the VHDLCompMap is not deleted.
  int remove (VHDLCompMap* v) { return VHDLObjList::remove(v); }

  // Find VHDLCompMap with given name (const, non-const forms).
  VHDLCompMap* vhdlCompMapWithName(const char* name) {
    return (VHDLCompMap*) vhdlObjWithName(name);
  }

  const VHDLCompMap* vhdlCompMapWithName(const char* name) const {
    return (const VHDLCompMap*) vhdlObjWithName(name);
  }

};

class VHDLCompMapListIter : public VHDLObjListIter {
 public:
  VHDLCompMapListIter(VHDLCompMapList& l) : VHDLObjListIter(l) {}
  VHDLCompMap* next() { return (VHDLCompMap*) VHDLObjListIter::next(); }
  VHDLCompMap* operator++(POSTFIX_OP) { return next(); }
  VHDLObjListIter::reset;
};

#endif
