#ifndef _VHDLGenericMap_h
#define _VHDLGenericMap_h 1
/******************************************************************
Version identification:
@(#)VHDLGenericMap.h	1.4 2/28/96

Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.

Permission is hereby granted, without written agreement and without
license or royalty fees, to use, copy, modify, and distribute this
software and its documentation for any purpose, provided that the
above copyright notice and the following two paragraphs appear in all
copies of this software.

IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY
FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS.

						PT_COPYRIGHT_VERSION_2
						COPYRIGHTENDKEY

 Programmer: Michael C. Williamson

 Methods defining VHDL GenericMaps.

*******************************************************************/
#ifdef __GNUG__
#pragma interface
#endif

#include "VHDLObj.h"
#include "VHDLObjList.h"

class VHDLGenericMap : public VHDLObj
{
 public:
  // Constructors.
  VHDLGenericMap();

  // Destructor.
  ~VHDLGenericMap();

  // Map binding.
  StringList mapping;

  // Class Idenitification.
  /* virtual */ int isA(const char*) const;
  /* virtual */ const char* className() const;

  VHDLGenericMap* newCopy();

 protected:
 private:
};

class VHDLGenericMapList : public VHDLObjList
{
  friend class VHDLGenericMapListIter;

 public:
  // Add VHDLGenericMap to list.
  void put(VHDLGenericMap& v) { VHDLObjList::put(v); }

  // Return first VHDLGenericMap on list (const, non-const forms).
  VHDLGenericMap* head() { return (VHDLGenericMap*) VHDLObjList::head(); }
  const VHDLGenericMap* head() const {
    return (const VHDLGenericMap*) VHDLObjList::head();
  }

  // Remove a VHDLGenericMap from the list.
  // Note:  the VHDLGenericMap is not deleted.
  int remove (VHDLGenericMap* v) { return VHDLObjList::remove(v); }

  // Find VHDLGenericMap with given name (const, non-const forms).
  VHDLGenericMap* vhdlGenericMapWithName(const char* name) {
    return (VHDLGenericMap*) vhdlObjWithName(name);
  }

  const VHDLGenericMap* vhdlGenericMapWithName(const char* name) const {
    return (const VHDLGenericMap*) vhdlObjWithName(name);
  }

  // Return a pointer to a new copy of the list.
  VHDLGenericMapList* newCopy();

  // Allocate memory for a new VHDLGenericMap and put it in the list.
  void put(StringList, StringList);
};

class VHDLGenericMapListIter : public VHDLObjListIter {
 public:
  VHDLGenericMapListIter(VHDLGenericMapList& l) : VHDLObjListIter(l) {}
  VHDLGenericMap* next() { return (VHDLGenericMap*) VHDLObjListIter::next(); }
  VHDLGenericMap* operator++(POSTFIX_OP) { return next(); }
  VHDLObjListIter::reset;
};

#endif
