#ifndef _VHDLPortMap_h
#define _VHDLPortMap_h 1
/******************************************************************
Version identification:
@(#)VHDLPortMap.h	1.4 2/28/96

Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.

Permission is hereby granted, without written agreement and without
license or royalty fees, to use, copy, modify, and distribute this
software and its documentation for any purpose, provided that the
above copyright notice and the following two paragraphs appear in all
copies of this software.

IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY
FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS.

						PT_COPYRIGHT_VERSION_2
						COPYRIGHTENDKEY

 Programmer: Michael C. Williamson

 Methods defining VHDL PortMaps.

*******************************************************************/
#ifdef __GNUG__
#pragma interface
#endif

#include "VHDLObj.h"
#include "VHDLObjList.h"

class VHDLPortMap : public VHDLObj
{
 public:
  // Constructors.
  VHDLPortMap();

  // Destructor.
  ~VHDLPortMap();

  // Map binding.
  StringList mapping;

  // Class Idenitification.
  /* virtual */ int isA(const char*) const;
  /* virtual */ const char* className() const;

  VHDLPortMap* newCopy();

 protected:
 private:
};

class VHDLPortMapList : public VHDLObjList
{
  friend class VHDLPortMapListIter;

 public:
  // Add VHDLPortMap to list.
  void put(VHDLPortMap& v) { VHDLObjList::put(v); }

  // Return first VHDLPortMap on list (const, non-const forms).
  VHDLPortMap* head() { return (VHDLPortMap*) VHDLObjList::head(); }
  const VHDLPortMap* head() const {
    return (const VHDLPortMap*) VHDLObjList::head();
  }

  // Remove a VHDLPortMap from the list.
  // Note:  the VHDLPortMap is not deleted.
  int remove (VHDLPortMap* v) { return VHDLObjList::remove(v); }

  // Find VHDLPortMap with given name (const, non-const forms).
  VHDLPortMap* vhdlPortMapWithName(const char* name) {
    return (VHDLPortMap*) vhdlObjWithName(name);
  }

  const VHDLPortMap* vhdlPortMapWithName(const char* name) const {
    return (const VHDLPortMap*) vhdlObjWithName(name);
  }

  // Return a pointer to a new copy of the list.
  VHDLPortMapList* newCopy();

  // Allocate memory for a new VHDLPortMap and put it in the list.
  void put(StringList, StringList);
};

class VHDLPortMapListIter : public VHDLObjListIter {
 public:
  VHDLPortMapListIter(VHDLPortMapList& l) : VHDLObjListIter(l) {}
  VHDLPortMap* next() { return (VHDLPortMap*) VHDLObjListIter::next(); }
  VHDLPortMap* operator++(POSTFIX_OP) { return next(); }
  VHDLObjListIter::reset;
};

#endif
